/*****
*
*   Array.js
*
*   copyright 2002, Kevin Lindsey
*
*   Add additional methods to the built-in Array object
*
*****/

/*****
*
*   foreach
*
*****/
Array.prototype.foreach = function(func) {
    for ( var i = 0; i < this.length; i++ )
        func(this[i]);
};


/*****
*
*   map
*
*****/
Array.prototype.map = function(func) {
    var result = new Array();

    for ( var i = 0; i < this.length; i++ )
        result.push( func(this[i]) );

    return result;
};


/*****
*
*   min
*
*****/
Array.prototype.min = function() {
    var min = this[0];

    for ( var i = 0; i < this.length; i++ )
        if ( this[i] < min ) min = this[i];

    return min;
}


/*****
*
*   max
*
*****/
Array.prototype.max = function() {
    var max = this[0];

    for ( var i = 0; i < this.length; i++ )
        if ( this[i] > max ) max = this[i];

    return max;
}
